Subject: Re: [bitcoindev] Re: Adding New BIP Editors

From: Antoine Riard <[email-masked]>
Date: Mon, 1 Apr 2024 21:14:20 +0100

Hi Michael,

Thanks for the thoughtful answer.

> I repeat having the BIPs repo under a different GitHub organization
> would *not* have resulted in a different outcome in the Taproot
> activation params or avoided that particular conflict. If Core
> maintainers had merged a BIPs PR or kicked Luke off as a BIPs editor
> that would have been a different outcome. There are costs to moving
> the BIPs repo to a different GitHub organization (existing links,
> discoverability, two GitHub organizations to worry about rather than
> one) and as long as Core maintainers don't overrule BIP editors in the
> BIPs repo there are no clear upsides.

Fair point, though I think it's more a one-time migration cost for
long-term returns.
I still believe we shall apply the principle of least privilege when we can.
This blog article is a good one to meditate:
https://laanwj.github.io/2016/05/06/hostility-scams-and-moving-forward.html

> Just as you don't need to be a maintainer to provide high quality pull
> request review in the Core repo you don't need to be a BIP editor to
> provide high quality pull request review in the BIPs repo. There is
> nothing to stop people who aren't BIP editors continuing to provide
> review of your work in English and a BIPs repo in English only needs
> BIP editors who are fluent in English.

That's a fair point too, terminology / high-quality review can be provided
by non-editors.
The worthiness of having non-English editors it's up if we see this as an
administrative task or editorial one in my opinion.

> I think we'd agree we are somewhere in between these pure extremes and
> I'd argue mostly towards the administrative task end. One of the
> reasons I think Kanzure, RubenSomsen and Murch are good BIP editor
> candidates is that they can also provide high quality pull request
> review before potentially merging but unlike the Core repo where bad
> ideas should never be merged a BIP editor will end up merging up pull
> requests they think are bad ideas that they would never want merged
> into Core. A BIP can get a BIP number and end up being rejected by
> Core or the broader community for example.

On the experience of the inheritance rule in bip125, I would say it's not
so bad if there is a minimum of editorial checks.
At least when the proposal starts to be "proposed" / "final". You don't
need at first how standards are aging with time.
It's not specific to BIP, we have this issue with the BOLTs which have been
amended many times to make things more robust.

I don't know if the BIP process should be more proactive "deprecating" /
"obsolating" / "cleaning-up" standards like done by the IETF.
(It's clearly another set of tasks far beyond the focus of this
discussion...).

> This seems even more bureaucratic to me. Different numbers to track,
> more complexity. There is a BINANA repo [0] for Bitcoin Inquisition
> for this kind of early experimentation for proposed consensus changes
> that aren't advanced enough to be BIPs.

That "fast-track" numbers assignment experiment might work with time. Let'
see.

> Personally I think it is fine as it is. We are discussing the
> potential addition of high quality BIP editors as only having one
> currently (Luke) is clearly not ideal. That will alleviate Luke as a
> single bottleneck. I do think it is time for an update to the BIP
> process (BIP 3) too so BIP editors have some guidance on how to treat
> bad ideas (how bad are we talking!) and are comfortable merging pull
> requests around attempted (successful or failed) soft fork
> activations. Ultimately though just like with Core maintainers there
> is going to be some personal judgment required especially during those
> cases where there isn't clear community consensus either way. Hence
> for those cases I'd be much more comfortable with say Kanzure,
> RubenSomsen or Murch than someone we know very little about and hasn't
> demonstrated a strong understanding of how Bitcoin works.

On the contrary, the BIP process should clearly bound BIP editors personal
judgement, especially at a time of lack of clear community consensus.
If there is one lesson of consensus activation or policy changes over the
last few years, it's better to "wait-and-proactively-build-more-consensus"
rather than "force-through".
Even if the "force-through" is coming from appointed editors or whatever,
practice and respect of the process matters over titles and roles in my
opinion.

For sure, anyone who has already championed a change in Bitcoin has fallen
short of impatience, myself included (e.g with mempoolfullrbf).
Yet, it's good to remember that a bit of technical conservatism,
over-reviewing and feedback collection is always welcome on the delicate
changes.

All that said, I said my opinion on the list of BIP candidates already and
I have nothing more to say.
I won't express myself further on this subject, too much code to write and
review.

Best,
Antoine

Le dim. 31 mars 2024 à 17:01, Michael Folkson <[email-masked]> a
écrit :

> Hi Antoine
>
> Thanks for the challenge. I think we are going to end up disagreeing
> on some things but perhaps the discussion is worth having.
>
> > Indeed, avoiding new conflicts like we have seen with Luke with Taproot
> activation params is a good reason to separate repositories in my opinion.
> Beyond, "security through distrusting" [0] is a very legitimate
> security philosophy including for communication space infrastructure.
>
> I repeat having the BIPs repo under a different GitHub organization
> would *not* have resulted in a different outcome in the Taproot
> activation params or avoided that particular conflict. If Core
> maintainers had merged a BIPs PR or kicked Luke off as a BIPs editor
> that would have been a different outcome. There are costs to moving
> the BIPs repo to a different GitHub organization (existing links,
> discoverability, two GitHub organizations to worry about rather than
> one) and as long as Core maintainers don't overrule BIP editors in the
> BIPs repo there are no clear upsides.
>
> > No, I wish to ensure that if the aim of the BIP is ensuring high-quality
> and readability of standards those ones are well-written, including when
> the original standard is contributed by someone non-native.
> I can only remember numerous times when my english technical texts
> have been kindly corrected by other contributors. Having editors
> understanding multiple languages helps in quality redaction.
>
> Just as you don't need to be a maintainer to provide high quality pull
> request review in the Core repo you don't need to be a BIP editor to
> provide high quality pull request review in the BIPs repo. There is
> nothing to stop people who aren't BIP editors continuing to provide
> review of your work in English and a BIPs repo in English only needs
> BIP editors who are fluent in English.
>
> > Beyond, from reading conversations it sounds there is a disagreement if
> it's an administrative task (i.e "assigning numbers") or editorial one (i.e
> "high-quality, well-written standards").
>
> I think we'd agree we are somewhere in between these pure extremes and
> I'd argue mostly towards the administrative task end. One of the
> reasons I think Kanzure, RubenSomsen and Murch are good BIP editor
> candidates is that they can also provide high quality pull request
> review before potentially merging but unlike the Core repo where bad
> ideas should never be merged a BIP editor will end up merging up pull
> requests they think are bad ideas that they would never want merged
> into Core. A BIP can get a BIP number and end up being rejected by
> Core or the broader community for example.
>
> > If we wish to make things less bureaucratic, we might actually separate
> the two tasks with different groups of BIP process maintainers :
> - assign temporary numbers for experimentation
> - wait for more-or-less finalized drafts written in a quality fashion
> - assign final numbers for standard candidate deployment
>
> This seems even more bureaucratic to me. Different numbers to track,
> more complexity. There is a BINANA repo [0] for Bitcoin Inquisition
> for this kind of early experimentation for proposed consensus changes
> that aren't advanced enough to be BIPs.
>
> > If you see other ways to dissociate the roles and make things less
> bureaucratic ? E.g having people only in charge of triage.
> If I remember correctly the IETF does not assign RFC numbers for draft
> proposals, and you generally have years of experimentation.
>
> Personally I think it is fine as it is. We are discussing the
> potential addition of high quality BIP editors as only having one
> currently (Luke) is clearly not ideal. That will alleviate Luke as a
> single bottleneck. I do think it is time for an update to the BIP
> process (BIP 3) too so BIP editors have some guidance on how to treat
> bad ideas (how bad are we talking!) and are comfortable merging pull
> requests around attempted (successful or failed) soft fork
> activations. Ultimately though just like with Core maintainers there
> is going to be some personal judgment required especially during those
> cases where there isn't clear community consensus either way. Hence
> for those cases I'd be much more comfortable with say Kanzure,
> RubenSomsen or Murch than someone we know very little about and hasn't
> demonstrated a strong understanding of how Bitcoin works.
>
> > PS: By the way, even at the United Nations, unanimity is not the rule,
> it's two-third of the general assembly. I think your analogy is not valid.
>
> Perhaps we can leave discussion of my imperfect analogies to a
> different forum :) Hopefully we can agree that this is a direction of
> travel that we shouldn't be pursuing for the BIPs repo.
>
> [0]: https://github.com/bitcoin-inquisition/binana
>
> On Sat, Mar 30, 2024 at 8:01 PM Antoine Riard <[email-masked]>
> wrote:
> >
> > Hi Michael,
> >
> > > In the past there have been disagreements between Core maintainers and
> > > BIP editors (e.g. Luke with Taproot activation params) and those Core
> > > maintainers haven't merged pull requests in the BIPs repo or removed
> > > him as a BIP editor. As long as that continues it isn't necessary to
> > > create a new GitHub organization for the BIPs repo. They are separate
> > > repos with different maintainers/editors but under the same
> > > organization and everyone knows where it is located.
> >
> > Indeed, avoiding new conflicts like we have seen with Luke with Taproot
> activation params is a good reason to separate repositories in my opinion.
> > Beyond, "security through distrusting" [0] is a very legitimate security
> philosophy including for communication space infrastructure.
> >
> > [0]
> https://www.qubes-os.org/news/2017/12/11/joanna-rutkowska-black-hat-europe-2017/
> >
> > > It seems like you want to create some kind of United Nations for the
> > > BIP process. As I said previously this is almost entirely an
> > > administrative task. Going to a committee of 10 people with different
> > > nationalities and languages to decide whether something should get a
> > > BIP number is absurd. If you think Luke is slow to respond wait until
> > > your United Nations of the BIP process has to all agree to assign a
> > > BIP number. Please don't try to make this unnecessarily bureaucratic
> > > and political for no reason. There's enough of that outside of
> > > Bitcoin.
> >
> > No, I wish to ensure that if the aim of the BIP is ensuring high-quality
> and readability of standards those ones are well-written, including when
> the original standard is contributed by someone non-native.
> > I can only remember numerous times when my english technical texts have
> been kindly corrected by other contributors. Having editors understanding
> multiple languages helps in quality redaction.
> >
> > Beyond, from reading conversations it sounds there is a disagreement if
> it's an administrative task (i.e "assigning numbers") or editorial one (i.e
> "high-quality, well-written standards").
> >
> > If we wish to make things less bureaucratic, we might actually separate
> the two tasks with different groups of BIP process maintainers :
> > - assign temporary numbers for experimentation
> > - wait for more-or-less finalized drafts written in a quality fashion
> > - assign final numbers for standard candidate deployment
> >
> > If you see other ways to dissociate the roles and make things less
> bureaucratic ? E.g having people only in charge of triage.
> > If I remember correctly the IETF does not assign RFC numbers for draft
> proposals, and you generally have years of experimentation.
> >
> > Best,
> > Antoine
> >
> > PS: By the way, even at the United Nations, unanimity is not the rule,
> it's two-third of the general assembly. I think your analogy is not valid.
> >
> > Le sam. 30 mars 2024 à 11:52, Michael Folkson <[email-masked]>
> a écrit :
> >>
> >> > In a world where both Core and BIP repository are living under a
> single Github organization, I don't think in matters that much as the
> highest privilege account will be able to
> >> override any BIP merging decision, or even remove on the flight BIP
> >> editors rights in case of conflicts or controversies. If you're
> >> raising the issue that the BIP repository should be moved to its own
> >> GH repository I think it's a valuable point.
> >>
> >> In the past there have been disagreements between Core maintainers and
> >> BIP editors (e.g. Luke with Taproot activation params) and those Core
> >> maintainers haven't merged pull requests in the BIPs repo or removed
> >> him as a BIP editor. As long as that continues it isn't necessary to
> >> create a new GitHub organization for the BIPs repo. They are separate
> >> repos with different maintainers/editors but under the same
> >> organization and everyone knows where it is located.
> >>
> >> > Beyond, I still think we should ensure we have a wider crowd of
> geographically and culturally diverse BIP editors. As if the role is
> ensuring high-quality and readability of the terminology of the standards,
> we might have highly-skilled technical BIP champions which are not English
> native. With the current set of proposed BIP editors, to the best of my
> knowledge, at least we have few langages spoken by the candidates: Dutch,
> French, German, Spanish. This can be very helpful to translate concepts
> devised in language A to technical english.
> >>
> >> It seems like you want to create some kind of United Nations for the
> >> BIP process. As I said previously this is almost entirely an
> >> administrative task. Going to a committee of 10 people with different
> >> nationalities and languages to decide whether something should get a
> >> BIP number is absurd. If you think Luke is slow to respond wait until
> >> your United Nations of the BIP process has to all agree to assign a
> >> BIP number. Please don't try to make this unnecessarily bureaucratic
> >> and political for no reason. There's enough of that outside of
> >> Bitcoin.
> >>
> >> On Fri, Mar 29, 2024 at 9:14 PM Antoine Riard <[email-masked]>
> wrote:
> >> >
> >> > > Roasbeef's work on alternative clients and lightning make him
> technically
> >> > useful
> >> >
> >> > I think one of the aim of the BIP process is to harmonize common
> mechanisms among Bitcoin clients of different langages breeds or at
> different layers (wallet / full-node).
> >> > Having someone among BIP editors with a proven track record of
> contributing to other full-node codebase beyond C++ can be valuable in that
> sense.
> >> > Especially for all matters related to compatibility and deployment.
> >> >
> >> > > For example I think Jon Atack would make a great Core maintainer at
> some point in the future and I'm not sure a BIP editor should also be a
> Core maintainer given the
> >> > > independence sometimes required between Core and the BIP process
> >> >
> >> > In a world where both Core and BIP repository are living under a
> single Github organization, I don't think in matters that much as the
> highest privilege account will be able to
> >> > override any BIP merging decision, or even remove on the flight BIP
> editors rights in case of conflicts or controversies. If you're raising the
> issue that the BIP repository should be moved to its own GH repository I
> think it's a valuable point.
> >> >
> >> > Beyond, I still think we should ensure we have a wider crowd of
> geographically and culturally diverse BIP editors. As if the role is
> ensuring high-quality and readability of the terminology of the standards,
> we might have highly-skilled technical BIP champions which are not English
> native. With the current set of proposed BIP editors, to the best of my
> knowledge, at least we have few langages spoken by the candidates: Dutch,
> French, German, Spanish. This can be very helpful to translate concepts
> devised in language A to technical english.
> >> >
> >> > Best,
> >> > Antoine
> >> >
> >> >
> >> > Le vendredi 29 mars 2024 à 12:33:09 UTC, /dev /fd0 a écrit :
> >> >>
> >> >> Justification:
> >> >>
> >> >> 1. Jon Atack: Good at avoiding controversies and technical
> documentation.
> >> >> 2. Roasbeef: Since BIPs are not just related to bitcoin core, it's
> good to have btcd maintainer as a BIP editor.
> >> >>
> >> >> On Friday, March 29, 2024 at 1:47:41 AM UTC+5:30 Matt Corallo wrote:
> >> >>>
> >> >>> Please provide justification rather than simply saying "I like
> Bob!".
> >> >>>
> >> >>> Matt
> >> >>>
> >> >>> On 3/28/24 12:09 PM, /dev /fd0 wrote:
> >> >>> > I support Jon Atack and Roasbeef from this list.
> >> >>> >
> >> >>> > On Thursday, March 28, 2024 at 6:57:53 PM UTC+5:30 Murch wrote:
> >> >>> >
> >> >>> > I just went through the thread, previously mentioned were:
> >> >>> >
> >> >>> > - Kanzure
> >> >>> > - Ruben Somsen
> >> >>> > - Greg Tonoski
> >> >>> > - Jon Atack
> >> >>> > - Roasbeef
> >> >>> > - Seccour
> >> >>> >
> >> >>> > And Matt just suggested me for the role. Hope I didn’t overlook
> anyone.
> >> >>> >
> >> >>> > On 3/27/24 19:39, John C. Vernaleo wrote:
> >> >>> > > That said, I would find it helpful if someone could go through
> the
> >> >>> > > thread and list all the people who've been proposed so people
> know who
> >> >>> > > they should be thinking about.
> >> >>> >
> >> >>> > --
> >> >>> > You received this message because you are subscribed to the
> Google Groups "Bitcoin Development
> >> >>> > Mailing List" group.
> >> >>> > To unsubscribe from this group and stop receiving emails from it,
> send an email to
> >> >>> > [email-masked] <mailto:
> [email-masked]>.
> >> >>> > To view this discussion on the web visit
> >> >>> >
> https://groups.google.com/d/msgid/bitcoindev/4c1462b7-ea1c-4a36-be81-7c3719157fabn%40googlegroups.com
> <
> https://groups.google.com/d/msgid/bitcoindev/4c1462b7-ea1c-4a36-be81-7c3719157fabn%40googlegroups.com?utm_medium=email&utm_source=footer
> >.
> >> >
> >> > --
> >> > You received this message because you are subscribed to the Google
> Groups "Bitcoin Development Mailing List" group.
> >> > To unsubscribe from this group and stop receiving emails from it,
> send an email to [email-masked].
> >> > To view this discussion on the web visit
> https://groups.google.com/d/msgid/bitcoindev/f8fa1a55-644f-4cf1-b8c1-4fdef22d1869n%40googlegroups.com
> .
> >>
> >>
> >>
> >> --
> >> Michael Folkson
> >> Personal email: [email-masked]
>
>
>
> --
> Michael Folkson
> Personal email: [email-masked]
>

-- 
You received this message because you are subscribed to the Google Groups "Bitcoin Development Mailing List" group.
To unsubscribe from this group and stop receiving emails from it, send an email to [email-masked].
To view this discussion on the web visit https://groups.google.com/d/msgid/bitcoindev/CALZpt%2BF%3DdUVn6bDLewjVVHGymhqYZgHQZ4yX%2BtfAPWx9gH_pzA%40mail.gmail.com.